/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "HW_Configs.h"

//   ------------------------------------------------------
extern int16_t AdcData[];

//   -----------------------------------------------------------

//    ----------------------------------------

/////////////  ,    /////////////////////////
void SYS_Config(void)
{
	//    -----------------------------------------------------
#ifdef NODEBUG
	if (FLASH_OB_GetRDP() == RESET) //     
	{
		FLASH_OB_Unlock(); //  
		FLASH_OB_RDPConfig(OB_RDP_Level_1);
		FLASH_OB_Lock(); //  
	}
#endif  

	//   -----------------------------------------------------------
#ifdef W_DOG
	IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable); //     
	IWDG_SetPrescaler(IWDG_Prescaler_16); // 40 / 16 = 400 -  
	IWDG_SetReload(2500); // 0.4 * 2500 = 1  -  
//	while(IWDG_GetFlagStatus(IWDG_FLAG_RVU) != RESET) {} //  
	IWDG_ReloadCounter(); //  
	IWDG_Enable(); //     LSI
#endif  
}


/////////////   /////////////////////////////////////////////
void SCK_Config(void)
{
	//  ----------------------------------------------------------------------
	RCC_DeInit(); //   " "
	RCC_HCLKConfig(RCC_SYSCLK_Div1); //   AHB
	RCC_PCLKConfig(RCC_HCLK_Div1); //    APB

#ifdef EXT_QUARZ //  
	RCC_HSEConfig(RCC_HSE_ON); //   
	if (RCC_WaitForHSEStartUp() == ERROR) //   
	{ //   -    
		RCC_HSEConfig(RCC_HSE_OFF); //   
		Delay_ms(120);
		NVIC_SystemReset();
	}
	else // 
	{
		RCC_ClockSecuritySystemCmd(ENABLE); //  CSS (  NMI)
		RCC_PREDIV1Config(RCC_PREDIV1_Div2); // 8MHz /2 (  /2  HSI)
		RCC_PLLConfig(RCC_PLLSource_PREDIV1, RCC_PLLMul_12); // PLLCLK = 8MHz /2 * 12 = 48 MHz
	}
#else //  
	RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_12); // PLLCLK = 8MHz /2 * 12 = 48 MHz
#endif

	RCC_PLLCmd(ENABLE); //  PLL
	while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET) {} //   PLL
	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK); //  SYSCLK  PLL
	while (RCC_GetSYSCLKSource() != 0x08) {} //     PLL
	// --------------------------------------------------------------------------
	SystemCoreClockUpdate (); //  SystemCoreClock =  
}


///////////// Configures GPIO //////////////////////////////////////////
void GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure; //    

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE); //     AHB
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE); //     AHB
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOF, ENABLE); //     AHB

	GPIO_DeInit(GPIOA); //   " "
	GPIO_DeInit(GPIOB); //   " "
	GPIO_DeInit(GPIOF); //   " "

	// ---------------    :
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_1); //   I2C1
	GPIO_PinAFConfig(GPIOB, GPIO_PinSource7, GPIO_AF_1); //    I2C1
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD; //   
	GPIO_Init(GPIOB, &GPIO_InitStructure); 

	// 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 

	// ---------------   :
	// 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_10|GPIO_Pin_11; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; // 
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5; //   
	GPIO_Init(GPIOB, &GPIO_InitStructure); // 

	// 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15; //   
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN; // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8; //   
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL; // 
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN; // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7|GPIO_Pin_9|GPIO_Pin_12; //   
	GPIO_Init(GPIOA, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_3|GPIO_Pin_4; //   
	GPIO_Init(GPIOB, &GPIO_InitStructure); // 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1; //   
	GPIO_Init(GPIOF, &GPIO_InitStructure); // 
}


///////////////////////////// Configures I2C ///////////////////////////////////////////
void I2C_Config(void)
{
	I2C_InitTypeDef I2C_InitStructure; //   

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE); //     APB1
	RCC_I2CCLKConfig(RCC_I2C1CLK_SYSCLK); // Configure I2C clock

	I2C_DeInit(I2C1); //   " "
	I2C_InitStructure.I2C_Timing = 0x10805E89; // (I2C_Timing_Config_Tool) 100k  48
//	I2C_InitStructure.I2C_Timing = 0x005018CC; // (I2C_Timing_Config_Tool) 200k  48
//	I2C_InitStructure.I2C_Timing = 0x00501953; // (I2C_Timing_Config_Tool) 400k  48
	I2C_InitStructure.I2C_AnalogFilter = I2C_AnalogFilter_Enable;
	I2C_InitStructure.I2C_DigitalFilter = 0x00; // digital noise filter. 0x00...0x0F
	I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
	I2C_InitStructure.I2C_OwnAddress1 = 0x00; // ..
	I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
	I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
	I2C_Init(I2C1, &I2C_InitStructure); // 
	I2C_Cmd(I2C1, ENABLE); // 
}


///////////////////////////// Configures ADC ///////////////////////////////////////////
void ADC_Config(void)
{
	ADC_InitTypeDef ADC_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE); // 
	ADC_ClockModeConfig(ADC1, ADC_ClockMode_SynClkDiv4); //  48/4=12
//	ADC_ClockModeConfig(ADC1, ADC_ClockMode_AsynClk); //     14

	ADC_DeInit(ADC1); //   " "
	ADC_StructInit(&ADC_InitStructure);
	ADC_InitStructure.ADC_Resolution = ADC_Resolution_12b; // 
	ADC_InitStructure.ADC_ContinuousConvMode = DISABLE; //   CONT=1
	ADC_InitStructure.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_Rising; // 
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_T2_TRGO; //   
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; // 
	ADC_InitStructure.ADC_ScanDirection = ADC_ScanDirection_Upward; //
	ADC_Init(ADC1, &ADC_InitStructure); 

	// ADC_SampleTime_1_5Cycles - fmax=857
	// ADC_SampleTime_7_5Cycles - fmax=600
	// ADC_SampleTime_13_5Cycles - fmax=461 --  12
	// ADC_SampleTime_13_5Cycles - fmax=538 --  14
	ADC_ChannelConfig(ADC1, ADC_Channel_0, ADC_SampleTime_71_5Cycles);
	ADC_ChannelConfig(ADC1, ADC_Channel_17, ADC_SampleTime_71_5Cycles);

	ADC_VrefintCmd(ENABLE); // 

//	ADC_DiscModeCmd(ADC1, ENABLE); //  DISCEN=1 
	ADC_OverrunModeCmd(ADC1, ENABLE); //   

	ADC_GetCalibrationFactor(ADC1); // 

	ADC_DMARequestModeConfig(ADC1, ADC_DMAMode_Circular); // 
	ADC_DMACmd(ADC1, ENABLE); //  
	ADC_Cmd(ADC1, ENABLE); // 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_ADRDY)); // Wait the ADRDY flag
	ADC_StartOfConversion(ADC1); // 
}



///////////////////////////// Configures USART ///////////////////////////////////////////
void TIM_Config(void) // ---------------------------------------------
{ 
	TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure; //   

	// *************** TIM2 *************  
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE); //  
	TIM_DeInit(TIM2); //   " "

	TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1; // 0       ETR
	TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; // 
	TIM_TimeBaseInitStructure.TIM_Period = (SYSCORECLOCK/ADCSMPL)- 1; //  
	TIM_TimeBaseInitStructure.TIM_Prescaler = 0x0000; //    TIM_Prescaler+1,   1
	TIM_TimeBaseInitStructure.TIM_RepetitionCounter = 0x00; //   TIM1,    
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStructure); // 

	TIM_SelectOutputTrigger(TIM2, TIM_TRGOSource_Update); //  
	TIM_Cmd(TIM2, ENABLE); // 
}

/////////////    /////////////////////
void DMA_Config(void)
{
	DMA_InitTypeDef   DMA_InitStructure;

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE); // Enable DMA1 clock

	DMA_DeInit(DMA1_Channel1); //   ADC
	DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&ADC1->DR;
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)&AdcData;
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
	DMA_InitStructure.DMA_BufferSize = LENSMPL;
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
	DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;
	DMA_InitStructure.DMA_Priority = DMA_Priority_High;
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
	DMA_Init(DMA1_Channel1, &DMA_InitStructure);
	DMA_ITConfig(DMA1_Channel1, DMA_IT_TC|DMA_IT_HT, ENABLE); //       
	DMA_Cmd(DMA1_Channel1, ENABLE);
}

/////////////    /////////////////////
void NVIC_Config(void)
{
	NVIC_InitTypeDef NVIC_InitStructure; //     

	//    DMA  ADC
	NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPriority = 1;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

	//      ( = 3,  )
	SysTick_Config(SystemCoreClock / 1000); // 1 mS
}

// -------------------------------------------------------------------------------------------------------



