#ifndef __MAIN_H /* Define to prevent recursive inclusion --------------------*/
#define __MAIN_H
#ifdef __cplusplus
 extern "C" {
#endif

//#define USE_FULL_ASSERT	// ,    

#include "stm32f0xx.h"
#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

//   -------------------------------------------------------------
#define _BITSET(bits) ((uint16_t)((bits % 010) | (bits / 010 % 010) << 1 | (bits / 0100 % 010) << 2 | \
  (bits / 01000 % 010) << 3 | (bits / 010000 % 010) << 4 | (bits / 0100000 % 010) << 5 | (bits / 01000000 % 010) << 6 | \
  (bits / 010000000 % 010) << 7 | (bits / 0100000000 % 010) << 8 | (bits / 01000000000 % 010) << 9 | (bits / 010000000000 % 010) << 10 | \
  (bits / 0100000000000 % 010) << 11 | (bits / 01000000000000 % 010) << 12 | (bits / 010000000000000 % 010) << 13 | \
  (bits / 0100000000000000 % 010) << 14 | (bits / 01000000000000000 % 010) << 15))
#define BIN(bits) _BITSET(0##bits)	// : BIN(111001100110)

#define BIT(n) (1UL<<(n))	// : BIT(2)|BIT(0) == 0b101 == 0x5
typedef enum {FALSE = 0, TRUE = !FALSE} bool;


// 
#define	SYSCORECLOCK	48000000UL
//    
#define	ADCSMPL			10000
//    ( 100)
#define	LENSMPL			2000UL

#define	KDEBOUNCE		11
#define	KUPRESS			350
#define	KDOUBLEMAX		300

#define	CAL_MCU_MV		3308
#define	TH_END_MV		2700
#define	CA_END_MV		4200
#define	R20_LOAD		19.65
#define	R10_LOAD		10.01

#define K1_GET()		(GPIOA->IDR & GPIO_Pin_15)

#define CH_OFF()		(GPIOA->MODER &= ~GPIO_MODER_MODER8_0)
#define CH_ON()			(GPIOA->MODER |= GPIO_MODER_MODER8_0)

#define LED_ON()		(GPIOA->BSRR = GPIO_Pin_11)
#define LED_OFF()		(GPIOA->BRR = GPIO_Pin_11)

#define L20_ON()		(GPIOA->BSRR = GPIO_Pin_10)
#define L20_OFF()		(GPIOA->BRR = GPIO_Pin_10)

#define L10_ON()		(GPIOA->BSRR = GPIO_Pin_2)
#define L10_OFF()		(GPIOA->BRR = GPIO_Pin_2)

#define	VREFINT_CAL 	(*((uint16_t*)0x1FFFF7BA))


enum Flags_e {READY,DISP,SEC,KEY1_DP,KEY1_U,KEY1_P};

 //  Optimize Level2 + for Time
#define DELAY_US(x)		{\
	uint32_t _dcnt;\
	_dcnt = x;\
	_dcnt *= SystemCoreClock / 8000000;\
	while (_dcnt-- != 0) {__asm(" nop");__asm(" nop");}}

//    ----------------------------------------
//__STATIC_INLINE 
void Delay_ms(uint32_t ms);


#ifdef __cplusplus
}
#endif
#endif /* __MAIN_H */

