#ifndef __TIC32_H
#define __TIC32_H
#ifdef __cplusplus
 extern "C" {
#endif

//  ------------------------------------------------------------
//TIC32 - 128x32
#define DISPX 127
#define DISPY 31

#define ADDR_LCD	0x78
#define DISP_LCD	0x40 //   
#define COM_LCD		0x80 //  

#define	WAIT_TXIS()	while(I2C_GetFlagStatus(I2C1,I2C_ISR_TXIS)==RESET){} // ,   TXIS   
#define	WAIT_STOP()	{while(I2C_GetFlagStatus(I2C1,I2C_ISR_STOPF)==RESET){};I2C_ClearFlag(I2C1,I2C_ICR_STOPCF);} //   STOPF

#define PIN_LCDRES_ON()	(GPIOB->BSRR = GPIO_Pin_5)
#define PIN_LCDRES_OFF() (GPIOB->BRR = GPIO_Pin_5)

//    ----------------------------------------
void LCD_Init(uint8_t Cont);
void LCD_Clear(uint8_t typ); //   , typ=0 , typ=1 
void LCD_Cursor(uint8_t X, uint8_t Y); // 
void LCD_SymbolBig(uint8_t codv, uint8_t X); //   16x32   X
void LCD_Symbol(uint8_t codv); //       
void LCD_String(char *str);//     

#ifdef __cplusplus
}
#endif
#endif /* __TIC32_H */
